#ifndef __Fp
#define __Fp
#include <iostream.h>

/*******************************************************************
arithmetic for the finit field Fp of characteristic p = prime < 32768
*******************************************************************/

struct Fp {
	// data
	int q;
	static int prime;
	// constructor
	Fp(int x = 0);
	Fp(Fp &x);
	// elements
	Fp& operator = (Fp &x);
	Fp& operator = (int x);
	Fp  operator + (Fp &y);
	Fp  operator - (Fp &y);
	Fp  operator * (Fp &y);
	Fp  operator / (Fp  y);
	friend Fp& operator + (Fp &x); // unary plus
	friend Fp  operator - (Fp &x); // unary minus
	Fp& operator *= (Fp &y);
	Fp& operator /= (Fp  y);
	Fp& operator += (Fp &y);
	Fp& operator -= (Fp &y);
	int operator != (Fp &y);
	int operator == (Fp &y);
	int operator != (int y);
	int operator == (int y);
	void invert();
	friend ostream& operator << (ostream &, Fp &);
	friend istream& operator >> (istream &, Fp &);
};

int len(Fp &x);

Fp pow(Fp &x, int n);

Fp abs(Fp x);

int sign(Fp &x);

#endif
