#ifndef __Fp8
#define __Fp8
#include <iostream.h>

/*******************************************************************
arithmetic for the finit field Fp of characteristic p = prime < 256
*******************************************************************/

struct Fp8 {
	// data
	unsigned char q;
	static int prime;
	static unsigned char add[256][256];
	static unsigned char sub[256][256];
	static unsigned char mul[256][256];
	static unsigned char div[256][256];
	// constructor
	Fp8(int x = 0);
	Fp8(Fp8 &x);
	// elements
	void init();

	Fp8& operator = (Fp8 &x);
	Fp8& operator = (int x);
	Fp8  operator + (Fp8 &y);
	Fp8  operator - (Fp8 &y);
	Fp8  operator * (Fp8 &y);
	Fp8  operator / (Fp8  y);
	friend Fp8& operator + (Fp8 &x); // unary plus
	friend Fp8  operator - (Fp8 &x); // unary minus
	Fp8& operator *= (Fp8 &y);
	Fp8& operator /= (Fp8  y);
	Fp8& operator += (Fp8 &y);
	Fp8& operator -= (Fp8 &y);
	int operator != (Fp8 &y);
	int operator == (Fp8 &y);
	int operator != (int y);
	int operator == (int y);
	void invert();
	friend ostream& operator << (ostream &, Fp8 &);
	friend istream& operator >> (istream &, Fp8 &);
};

int len(Fp8 &x);

Fp8 abs(Fp8 x);

int sign(Fp8 &x);

#endif
