#ifndef __monom
#define __monom
#include <iostream.h>
extern int dim;

/*******************************************************************
monom
*******************************************************************/

struct monom {
	// data
	int dim;
	char *exp;
	// constuctors
	monom (monom &x);
	monom (char x = 0);
	// destructor
	~monom ();
	// elements
	monom& operator  = (monom &x);
	monom& operator  = (char x);
	monom& operator *= (monom &x);
	monom& operator /= (monom &x);
	monom operator * (monom &y);
	monom operator / (monom &y);
	int   operator >  (monom &y);
	int   operator <  (monom &y);
	int   operator >= (monom &y);
	int   operator <= (monom &y);
	int   operator != (monom &y);
	int   operator == (monom &y);
	int tot_deg();
	int vars();
	void put(ostream &s);
	// friends
	friend ostream& operator << (ostream &s, monom &x);
};

int lex_lt (monom &x, monom &y);
int lex_le (monom &x, monom &y);
int revlex_lt (monom &x, monom &y);
int revlex_le (monom &x, monom &y);
int deglex_lt (monom &x, monom &y);
int deglex_le (monom &x, monom &y);
int degrevlex_lt (monom &x, monom &y);
int degrevlex_le (monom &x, monom &y);
int Zn_order_lt (monom &x, monom &y);
int Zn_order_le (monom &x, monom &y);
int proj_deglex_lt (monom &x, monom &y);
int proj_deglex_le (monom &x, monom &y);
int proj_degrevlex_lt (monom &x, monom &y);
int proj_degrevlex_le (monom &x, monom &y);

int len(monom &m);
int sign(monom &x);
monom lcm(monom &x, monom &y);
monom gcd(monom &x, monom &y);
void prj(monom &x);

#endif